<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN">
<html>
<head>
  <meta http-equiv="content-type"
 content="text/html; charset=ISO-8859-1">
  <title>Esame</title>
</head>
<body>
<span style="font-weight: bold;">Esame di Sistemi Operativi 1 : 14
Gennaio 2004 </span><br>
<span style="font-weight: bold;"><br>
Punteggio</span>
<table cellpadding="2" cellspacing="2" border="0"
 style="text-align: left; width: 600px;">
  <tbody>
    <tr>
      <td style="vertical-align: top;"><br>
      </td>
      <td style="vertical-align: top;">D1<br>
      </td>
      <td style="vertical-align: top;">D2<br>
      </td>
      <td style="vertical-align: top;">D3<br>
      </td>
      <td style="vertical-align: top;">D4<br>
      </td>
      <td style="vertical-align: top;">D5<br>
      </td>
      <td style="vertical-align: top;">E1<br>
      </td>
      <td style="vertical-align: top;">E2<br>
      </td>
      <td style="vertical-align: top;">E3<br>
      </td>
      <td style="vertical-align: top;">E4<br>
      </td>
      <td style="vertical-align: top;">E5 </td>
      <td style="vertical-align: top;">Totale<br>
      </td>
    </tr>
    <tr>
      <td style="vertical-align: top;">Punti<br>
      </td>
      <td style="vertical-align: top;">4<br>
      </td>
      <td style="vertical-align: top;">3<br>
      </td>
      <td style="vertical-align: top;">3<br>
      </td>
      <td style="vertical-align: top;">3<br>
      </td>
      <td style="vertical-align: top;">3<br>
      </td>
      <td style="vertical-align: top;">6<br>
      </td>
      <td style="vertical-align: top;">4<br>
      </td>
      <td style="vertical-align: top;">2<br>
      </td>
      <td style="vertical-align: top;">2<br>
      </td>
      <td style="vertical-align: top;">2 </td>
      <td style="vertical-align: top;">32<br>
      </td>
    </tr>
  </tbody>
</table>
&nbsp;
<ul>
  <li><a href="#TIPOA">Tipo A</a></li>
  <li><a href="#TIPOB">Tipo B</a></li>
</ul>
<hr>
<p><span style="font-weight: bold;"><a name="TIPOA"></a>Tipo A</span></p>
<p><span style="font-weight: bold;"><br>
Domanda 1</span><span style="font-weight: bold;"><span
 style="font-weight: bold;"></span></span><br>
Definire le proprieta' di mutua esclusione, progresso e bounded
waiting. <br>
Mostrare&nbsp; un'esempio di programma concorrente per il quale vale
progresso ma non vale <br>
bounded waiting.</p>
<p><b><i>Soluzione</i></b><br>
Mutua esclusione: se il processo Pi sta eseguendo la<br>
sua sezione critica, allora nessun altro processo pu&ograve; eseguire la<br>
propria sezione critica.<br>
<br>
Progresso: se nessun processo &egrave; nella sezione critica e<br>
esiste un processo che desidera entrare nella propria sezione<br>
critica, allora l'esecuzione di tale processo non pu&ograve; essere<br>
posposta indefinitamente.</p>
<p>Attesa limitata (bounded waiting): se un processo P ha richiesto di
entrare<br>
nella propria sezione critica, allora il numero di volte che si<br>
concede agli altri processi di accedere alla propria sezione critica<br>
prima del processo P deve essere limitato.</p>
<p>In un programma in cui la scelta del processo &egrave; fatta in modo
casuale
dall'insieme dei processi<br>
in attesa (ad es. utilizzando numeri random) vale progresso ma non
bounded
waiting (un processo&nbsp;<br>
potrebbe soffrire di starvation).</p>
<p>
<br>
<span style="font-weight: bold;">Domanda 2<br>
</span>Descrivere la differenza fondamentale tra una trap e
un'interruzione.<br>
</p>
<p><b><i>Soluzione</i></b></p>
<p>Le trap e le interruzioni sono alla base del funzionamento dual-mode
di un
sistema operativo.<br>
Una trap &egrave; generata da una chiamata software al sistema
operativo e permette di
passare da esecuzione&nbsp;<br>
a livello utente ad esecuzione a livello kernel.&nbsp;</p>
<p>Un'interruzione &egrave; causata invece da un dispositivo hardware e
provoca il
passaggio a modalit&agrave; kernel&nbsp;<br>
per la gestione di eventi quali la terminazione di operazioni di I/O.</p>
<p>
<br>
<span style="font-weight: bold;">Domanda 3</span><br>
Descrivere il meccanismo di gestione degli accessi alla pagine logiche
in un sistema <br>
&nbsp;con paginazione munito di TLB.<span style="font-weight: bold;"><span
 style="font-weight: bold;"><br>
</span></span></p>
<p><b><i>Soluzione</i></b></p>
<p>Il doppio accesso alla memoria si riduce con una cache dedicata per<br>
le entry delle page tables: \emph{registri associativi} detti anche<br>
Il translation look-aside buffer (TLB) &egrave; un insieme di registri
associativi&nbsp;<br>
utilizzati per memorizzare le entry della page table utilizzate
pi&ugrave;
frequentemente.<br>
Il virtual page number A viene confrontato con tutte le entry<br>
contemporaneamente. Se A &egrave; nel TLB (TLB hit), si usa il numero
del frame&nbsp;<br>
nel TLB. Altrimenti, la MMU esegue un normale lookup nelle page table
in memoria,<br>
e sostituisce una entry della TLB con quella appena trovata.&nbsp;<br>
Il S.O. viene informato solo nel caso di un page fault&nbsp;<br>
(...protezioni, validit&agrave;, ...).<br>
<br>
Variante software: I TLB miss vengono gestiti direttamente dal S.O.<br>
nel caso di una TLB miss, la MMU manda un interrupt al<br>
processore (TLB fault), si attiva una apposita routine del S.O., che
gestisce le page table<br>
e la TLB esplicitamente.&nbsp;</p>
<p><span style="font-weight: bold;"><br>
Domanda 4<br>
</span>Descrivere l'algoritmo del clock a due lancette
utilizzato dal demone delle pagine di Unix.<br>
</p>
<p><b><i>Soluzione</i></b></p>
<p>Pagedaemon utilizza una politica di rimpiazzamento&nbsp; globale<br>
(non si guarda il processo a cui appartiene la pagina) e una<br>
variante dell'algoritmo dell'orologio: l'orologio (CLOCK) a 2 lancette.<br>
L'algoritmo usa due puntatori (lancette) per scorrere<br>
la lista delle pagine allocate nella&nbsp; core map<br>
Fino a che NFL &lt; lotsfree si eseguono i seguenti passi:<br>
La prima lancetta azzera il reference bit della pagina a cui punta<br>
correntemente; La seconda sceglie la pagina vittima: se trova r=0 (i.e.
la pagina non
&egrave; stata usata nel periodo trascorso<br>
tra il passaggio delle due lancette): Se dirty-bit=1 il frame viene
salvato su disco<br>
il frame viene aggiunto alla free-list poi si fanno avanzare i due
puntatori.<br>
<br>
La distanza tra i puntatori (handspread) viene decisa al boot, per
liberare frame&nbsp;<br>
abbastanza rapidamente. Se le lancette sono vicine: solo le pagine
realmente usate
rimarranno in memoria<br>
Se le lancette sono distanti 359 gradi = algoritmo dell'orologio (la
seconda passa dopo un giro)<br>
<br>
<span style="font-weight: bold;"><span style="font-weight: bold;">Domanda
5</span></span><br>
Descrivere le caratteristiche principali e confrontare tra loro (con un
occhio di <br>
riguardo alla capacita' di indirizzamento) i file system
FAT-12, FAT-16 e FAT-32 e <br>
un file system basato su i-node stile Unix.</p>
<p><br>
<span style="font-weight: bold; font-style: italic;">Soluzione:</span><br>
I file system FAT-12, FAT-16 e FAT-32 utilizzano la FAT (mem.
all'inizio di un disco) per tenere traccia dei blocchi fisici associati
ad un file.<br>
La FAT e' una tabella indicizzata sul numero di blocco fisico. Il
contenuto di una entry rappresenta il blocco seguente di un determinato
file<br>
(cioe' una FAT rappresenta un'insieme di liste concatenate).<br>
La differenza tra i vari FS FAT sta nel numero di bit utilizzati per
l'indirizzamento del disco (risp. 12, 16, 28).<br>
La capacita' dipende dalla dimensione dei blocchi:<br>
-- FAT-12 da&nbsp; 2MB (blocchi da 0.5KB) a 16 MB (blocchi da 4KB)<br>
-- FAT-16 da&nbsp; 128MB (blocchi da 2KB) a 2048 MB (blocchi da 32KB)<br>
-- FAT-32 da&nbsp; 1TB (blocchi da 4KB) a 2TB (blocchi da 324KB)<br>
<br>
In Unix gli indirizzi di blocco sono mantenuti dentro un'inode (insieme
as altre info sul file): <br>
10 indirizzi diretti, 1 singolo indiretto, 1 doppio indiretto.<br>
La capacita' dipende dalla dim. dei blocchi e dei puntatori: con
blocchi da 4KB e puntatori da 4byte ~ 4TB<br>
<br>
<br>
<span style="font-weight: bold;">Esercizio 1<br>
</span>Considerate i seguenti&nbsp; processi</p>
<table cellpadding="2" cellspacing="2" border="0"
 style="text-align: left; width: 700px;">
  <tbody>
    <tr>
      <td style="vertical-align: top; text-align: left;" rowspan="1"
 colspan="2"><span style="font-weight: bold;">Risorse condivise</span><br>
&nbsp; <span style="font-weight: bold;">semaphore</span>&nbsp; S=<span
 style="font-weight: bold;">1</span>, T=<span style="font-weight: bold;">1</span>,
U=<span style="font-weight: bold;">0</span>;<br>
&nbsp; <span style="font-weight: bold;">int</span> x=0;<br>
      </td>
      <td style="vertical-align: top;"><br>
      </td>
    </tr>
    <tr>
      <td style="vertical-align: top;"><span style="font-weight: bold;">Processo</span>
P1<br>
{<br>
      <span style="font-weight: bold;">&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;
down</span>(&amp;S); <br>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; <span style="font-weight: bold;">if</span>
(x=0) <span style="font-weight: bold;">then</span> <span
 style="font-weight: bold;">up</span>(&amp;T)<br>
&nbsp;&nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp;
&nbsp;&nbsp;&nbsp;&nbsp; <span style="font-weight: bold;">else</span> <span
 style="font-weight: bold;">up</span>(&amp;U);<br>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; x:=3;<br>
      <span style="font-weight: bold;">&nbsp;&nbsp;&nbsp;&nbsp; write</span>(x);<br>
}<br>
      </td>
      <td style="vertical-align: top; width: 50%;"><span
 style="font-weight: bold;">Processo</span> P2<br>
{<br>
&nbsp;&nbsp;&nbsp; <span style="font-weight: bold;">down</span>(&amp;T);
      <br>
&nbsp;&nbsp;&nbsp; x:=1;<br>
&nbsp;&nbsp;&nbsp; <span style="font-weight: bold;">up</span>(&amp;S);&nbsp;&nbsp;&nbsp;
      <br>
}<br>
      </td>
      <td style="vertical-align: top;"><span style="font-weight: bold;">Processo</span>
P3<br>
{<br>
&nbsp;&nbsp;&nbsp; <span style="font-weight: bold;">down</span>(&amp;U);&nbsp;
      <br>
&nbsp;&nbsp;&nbsp; x:=10;<br>
&nbsp;&nbsp;&nbsp; <span style="font-weight: bold;">up</span>(&amp;S);<br>
}</td>
    </tr>
  </tbody>
</table>
<br>
supponete che i processi vengano eseguiti concorrentemente sulla stessa
CPU.
<p class="MsoHeader" style=""><o:p></o:p></p>
<!--[if !supportEmptyParas]-->
<ol>
  <li>In questo programma possono verificarsi <span
 style="font-weight: bold;">race conditions</span> per la variabile x?
(Motivare la risposta)<br>
    <br>
  </li>
  <li>Quali output vengono prodotti da tale programma concorrente?
(Motivare la risposta)<br>
    <br>
  </li>
  <li>Cosa succede se inseriamo l'istruzione<span
 style="font-weight: bold;"> down</span>(&amp;S) nel processo <span
 style="font-weight: bold;">P1</span> subito prima dell'istruzione <span
 style="font-weight: bold;">write</span>(x)?<span
 style="font-weight: bold;"><br>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; ...</span><br>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; x:=3;<br>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; down(&amp;S);<br>
    <span style="font-weight: bold;">&nbsp;&nbsp;&nbsp;&nbsp; write</span>(x);<br>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; ...<br>
  </li>
</ol>
<span style="font-weight: bold;"><span style="font-style: italic;">Soluzione</span><br>
</span><br>
<li>Si, la variabile x non 'e protetta adeguatamente. Ad esempio, P1
e P2 possono accedere ad x simultaneamente.</li>
<li>In generale: P1 e P2 lavorano in concorrenza (race conditions su
x). <br>
P3 puo partire solo dopo P2 e solo se P3 pone x=1;<br>
Quando attivi P1 e P3 lavorano in concorrenza (race conditions su x).<br>
Vi sono quindi vari interleaving:<br>
</li>
<ol>
  <li>Viene eseguito prima tutto P1: stampa 3<br>
  </li>
  <li>Viene eseguito P1 fino a x:=3, poi P2 pone x a 1, e quindi P2
stampa 1<br>
  </li>
  <li>Viene eseguito prima P2, poi P1 che trova x&gt;0, sveglia P3,
P3 pero' e' l'ultimo a modificare x: stampa 3<br>
  </li>
  <li>Viene eseguito prima P2, poi P1 che trova x&gt;0, sveglia P3,
si blocca dopo aver modificato x, poi viene mandato in esecuzione P3, e
poi si torna a P1: stampa 10</li>
</ol>
<li>Cosi' facendo inseriamo un punto di sincronizzazione in P1:
write(x) verra' eseguita solo se P2 o P3 hanno prima eseguito una up.<br>
Tuttavia rimangono le race conditions tra i tre assegnamenti. <br>
Quindi i possibili output rimangono sempre 1, 3 e 10.</li>
<br>
<span style="font-weight: bold;"><br>
Esercizio 2</span><br>
Cinque processi, <i>P<sub>1</sub></i>, <i>P<sub>2</sub></i>, <i>P<sub>3</sub></i>,
<i>P<sub>4</sub></i> e <i>P<sub>5</sub></i> richiedono
contemporaneamente di poter utilizzare la CPU.<br>
La lunghezza dei
CPU-burst&nbsp; e le priorit&agrave; sono dati nella
seguente tabella (supponiamo che numeri bassi <br>
corrispondano a
priorit&agrave; alte e viceversa):
<br>
<br>
<table cellpadding="3" border="0">
  <tbody>
    <tr valign="top">
      <td align="left" nowrap="nowrap">&nbsp;</td>
      <td align="right" nowrap="nowrap"><i>P<sub>1</sub></i></td>
      <td align="right" nowrap="nowrap"><i>P<sub>2</sub></i></td>
      <td align="right" nowrap="nowrap"><i>P<sub>3</sub></i></td>
      <td align="right" nowrap="nowrap"><i>P<sub>4</sub></i></td>
      <td align="right" nowrap="nowrap"><i>P<sub>5</sub></i></td>
    </tr>
    <tr valign="top">
      <td align="left" nowrap="nowrap">CPU burst</td>
      <td align="right" nowrap="nowrap">10</td>
      <td align="right" nowrap="nowrap">6</td>
      <td style="text-align: right; white-space: nowrap;">2</td>
      <td align="right" nowrap="nowrap">4</td>
      <td align="right" nowrap="nowrap">8</td>
    </tr>
    <tr valign="top">
      <td align="left" nowrap="nowrap">Priorit&agrave;</td>
      <td align="right" nowrap="nowrap">3</td>
      <td align="right" nowrap="nowrap">5</td>
      <td align="right" nowrap="nowrap">2</td>
      <td align="right" nowrap="nowrap">1</td>
      <td align="right" nowrap="nowrap">4</td>
    </tr>
  </tbody>
</table>
<p>
Disegnare il diagramma di Gantt e calcolare il tempo di completamento
di ogni processo
per ciascuna
<br>
delle seguenti politiche di scheduling della CPU:
</p>
<ol>
  <li>FIFO (supponendo che i processi siano stati inseriti in coda in
ordine crescente di indice)&nbsp;<strong></strong></li>
  <li><strong></strong>&nbsp;Shortest Job First&nbsp;<strong></strong></li>
  <li><strong></strong>&nbsp;Priorit&agrave;&nbsp;<strong></strong></li>
  <li><strong></strong>&nbsp;Round Robin (con quanto di tempo <i>q</i>
= 2 e trascurando il tempo di context switch) </li>
</ol>
<span style="font-weight: bold;">Soluzione:<br>
</span>
<ol>
  <li>FIFO<br>
Gantt chart:<br>
P1 (0-10), P2 (10-16), P3 (16-18), P4 (18-22), P5
(22-30)&nbsp;&nbsp; <br>
    <br>
Tempi di completamento:<br>
P1: 10, <br>
P2: 16, <br>
P3: 18, <br>
P4:22, <br>
P5: 30<br>
    <br>
  </li>
  <li>SJF<br>
Gantt chart:<br>
P3 (0-2), P4 (2-6), P2 (6-12), P5 (12-20), P1 (20-30) <br>
    <br>
Tempi di completamento:<br>
P1: 30, <br>
P2: 12, <br>
P3: 2, <br>
P4:6, <br>
P5: 20<br>
    <br>
  </li>
  <li>Priorit&agrave; <br>
Gantt chart:<br>
P4 (0-4), P3 (4-6), P1 (6-16), P5 (16-24), P2 (24-30)&nbsp;&nbsp; <br>
    <br>
Tempi di completamento:<br>
P1: 16, <br>
P2: 30, <br>
P3: 6, <br>
P4:4, <br>
P5: 20<br>
    <br>
  </li>
  <li>Round Robin<br>
Gantt chart:<br>
P1 (0-2), P2 (2-4), P3 (4-6), P4 (6-8), P5 (8-10),P1 (10-12), P2
(12-14), P4 (14-16), <br>
P5 (16-18),P1 (18-20), P2 (20-22), P5
(22-24),P1(24-26),P5(26-28),P1(28-30)<br>
    <br>
Tempi di completamento:<br>
P1: 30, <br>
P2: 22, <br>
P3: 6, <br>
P4:16, <br>
P5: 28</li>
</ol>
<span style="font-weight: bold;">Esercizio 3<br>
</span>Considerate la seguente <span style="font-weight: bold;">lista
circolare</span> associata alle pagine utilizzate dal processo A:<br>
<br>
&nbsp; (P1, 10, 1,&nbsp; 0) --&gt; (P2,&nbsp; 9, 0, 0) --&gt; (P3, 5,
0, 1) --&gt; (P4, 7 ,0, 0 ) --&gt; (P5, 11 ,0, 1 )&nbsp; -&gt;&nbsp;
puntatore all'indietro a P1&nbsp;
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;
&nbsp; &nbsp; &nbsp; &nbsp; <br>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; <br>
dove in (N,T,R,M): N=Numero della pagina; T=Tempo di
ultimo uso; R=Reference bit;&nbsp; M=Modified bit.<br>
Supponete che il processo A abbia bisogno di caricare la pagina P6 e
che occorra rimpiazzare una esistente.<br>
<br>
Determinare la pagina selezionata per il rimpiazzamento e la nuova
lista delle pagine ottenuta utilizzando <br>
l'algoritmo WSClock&nbsp; con le seguenti assunzioni: contatore del
tempo virtuale di CPU del
processo A = 12; <br>
periodo del working set =4; la lancetta punta
inizialmete a P1.<br>
<p>
<span style="font-weight: bold; font-style: italic;">Soluzione:<br>
</span>Viene selezionata la pagina P4 (P1 e P2 sono nel ws, P3 ha il
bit M a 1).<br>
La nuova lista e' <br>
<br>
(P1, 10, 0,&nbsp; 0) --&gt; (P2,&nbsp; 9, 0, 0) --&gt; (P3, 5,
0, 0*) --&gt; (P6, 12 ,1, 0 ) --&gt; (P5, 11 ,0, 1 ) <br>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;
| <br>
0*= se supponiamo che la copia su disco vada a buon fine.<br>
</p>
<p>
<br>
<span style="font-weight: bold;">
Esercizio 4</span><br>
Dato un file system
FAT con blocchi di 2KB&nbsp; e il seguente frammento di FAT, <span
 lang="IT"><br>
dire in
quali blocchi fisici sono collocati i seguenti byte:</span><span
 lang="IT"><br>
</span>
</p>
<ol>
  <li><span lang="IT">byte 6758 del file "pippo" che inizia al blocco 4<br>
    </span></li>
  <li><span lang="IT">byte 4097 del file "pluto" che inizia al blocco
3</span></li>
  <li><span lang="IT">byte 2044 del file "paperino" che inizia al
blocco 5<br>
    </span></li>
</ol>
<p class="MsoNormal" style="border: medium none ; padding: 0cm;"><span
 lang="IT">Frammento FAT :</span></p>
<table cellpadding="2" cellspacing="2" border="0"
 style="text-align: left; width: 100px;">
  <tbody>
    <tr>
      <td style="vertical-align: top;">Entry<br>
      </td>
      <td style="vertical-align: top;">Contenuto<br>
      </td>
    </tr>
    <tr>
      <td style="vertical-align: top;">0<br>
      </td>
      <td style="vertical-align: top;">10<br>
      </td>
    </tr>
    <tr>
      <td style="vertical-align: top;">1<br>
      </td>
      <td style="vertical-align: top;">2<br>
      </td>
    </tr>
    <tr>
      <td style="vertical-align: top;">2<br>
      </td>
      <td style="vertical-align: top;">0<br>
      </td>
    </tr>
    <tr>
      <td style="vertical-align: top;">3<br>
      </td>
      <td style="vertical-align: top;">6<br>
      </td>
    </tr>
    <tr>
      <td style="vertical-align: top;">4<br>
      </td>
      <td style="vertical-align: top;">1<br>
      </td>
    </tr>
    <tr>
      <td style="vertical-align: top;">5<br>
      </td>
      <td style="vertical-align: top;">8<br>
      </td>
    </tr>
    <tr>
      <td style="vertical-align: top;">6<br>
      </td>
      <td style="vertical-align: top;">7<br>
      </td>
    </tr>
    <tr>
      <td style="vertical-align: top;">7<br>
      </td>
      <td style="vertical-align: top;">11<br>
      </td>
    </tr>
    <tr>
      <td style="vertical-align: top;">8<br>
      </td>
      <td style="vertical-align: top;">12<br>
      </td>
    </tr>
  </tbody>
</table>
&nbsp;
<p><span style="font-weight: bold; font-style: italic;">Soluzione</span><br>
</p>
<ol>
  <li>Dim. blocco = 2*1024= 2048 bytes. Il byte 6758 di pippo si trova
nel quarto blocco <br>
Percorrendo la FAT: I blocco: 4, II blocco: 1, III blocco: 2, IV
blocco: 0<br>
Quindi l'indirizzo fisico del blocco e' <span
 style="font-weight: bold;">0</span><br>
    <br>
  </li>
  <li>Il byte 4096 di pluto si trova nel secondo (terzo) blocco se si
parte da 1 (0), quindi nel blocco fisico <span
 style="font-weight: bold;">6</span> (<span style="font-weight: bold;">7</span>).<br>
    <br>
  </li>
  <li><span lang="IT">Il byte 2044 del file "paperino" si trova nel
primo blocco, quindi </span>nel blocco fisico <span
 style="font-weight: bold;">5</span>.</li>
</ol>
<p>
<br>
<span style="font-weight: bold;">Esercizio 5</span><br>
In una organizzazione dell'allocazione dei file simile a
quella adottata in UNIX vi sono 14 puntatori nel descrittore di file <br>
(mantenuto in memoria durante l'accesso al file) di cui</p>
<ul>
  <li> 12 puntatori diretti a blocchi </li>
  <li> 1 puntatore indiretto a blocchi </li>
  <li> 1 puntatore doppiamente indiretto a blocchi </li>
</ul>
Se la dimensione di un blocco &egrave; 1Kb, e un puntatore occupa 4
bytes:<br>
<ol>
  <li>&nbsp;Qual &egrave; la dimensione massima di un file per il quale
non sono necessari accessi aggiuntivi per accedere a qualunque blocco?<br>
  </li>
  <li>&nbsp;Qual &egrave; la dimensione massima di un file? <br>
  </li>
  <li>Quanti accessi aggiuntivi sono necessari per accedere al byte
alla posizione 300K?<br>
  </li>
</ol>
<span style="font-weight: bold; font-style: italic;">Soluzione</span><br
 style="font-weight: bold; font-style: italic;">
Un blocco puo' contenere (dim. blocco/dim.puntatore=) 1024/4=256
puntatori a blocchi.<span style="font-weight: bold;"><br>
</span>
<ol>
  <li>La dim. massima di un file con blocchi accessibili solo tramite
puntatori diretti e' 12*1KB=12 KB.<br>
    <br>
  </li>
  <li>La dim. massima di un file indirizzabile e' 12 KB+256 KB+256<sup>2
    </sup>KB=65804 KB<br>
    <br>
  </li>
  <li>Il 300000-esimo byte di un file si trova in un blocco accessibile
tramite puntatore doppiamente indiretto: <br>
occorrono quindi 2 accessi aggiuntivi (uno alla tabella esterna e uno a
quella interna).<br>
  </li>
</ol>
<p>&nbsp;</p>
<hr>
<span style="font-weight: bold;"></span><span style="font-weight: bold;"><br>
<a name="TIPOB"></a>Tipo B
</span>
<p><span style="font-weight: bold;">Esame di Sistemi Operativi 1
-&nbsp; 14
Gennaio 2004</span><br>
<br>
<span style="font-weight: bold;"><br>
Punteggio</span><br>
<table cellpadding="2" cellspacing="2" border="0"
 style="text-align: left; width: 600px;">
  <tbody>
    <tr>
      <td style="vertical-align: top;"><br>
      </td>
      <td style="vertical-align: top;">D1<br>
      </td>
      <td style="vertical-align: top;">D2<br>
      </td>
      <td style="vertical-align: top;">D3<br>
      </td>
      <td style="vertical-align: top;">D4<br>
      </td>
      <td style="vertical-align: top;">E1<br>
      </td>
      <td style="vertical-align: top;">E2<br>
      </td>
      <td style="vertical-align: top;">E3<br>
      </td>
      <td style="vertical-align: top;">E4<br>
      </td>
      <td style="vertical-align: top;">E5<br>
      </td>
      <td style="vertical-align: top;">Totale<br>
      </td>
    </tr>
    <tr>
      <td style="vertical-align: top;">Punti<br>
      </td>
      <td style="vertical-align: top;">5<br>
      </td>
      <td style="vertical-align: top;">3<br>
      </td>
      <td style="vertical-align: top;">4<br>
      </td>
      <td style="vertical-align: top;">4<br>
      </td>
      <td style="vertical-align: top;">6<br>
      </td>
      <td style="vertical-align: top;">4<br>
      </td>
      <td style="vertical-align: top;">2<br>
      </td>
      <td style="vertical-align: top;">2<br>
      </td>
      <td style="vertical-align: top;">2<br>
      </td>
      <td style="vertical-align: top;">32<br>
      </td>
    </tr>
  </tbody>
</table>
<span style="font-weight: bold;"><br>
Domanda 1</span><br>
Descrivere in pseudo codice una soluzione al problema del
produttore-consumatore
con i monitor.<br>
</p>
<p><b><i>Soluzioni<br>
</i></b>Vedi lucidi</p>
<p><br>
<span style="font-weight: bold;">Domanda 2</span><br>
Cos'&egrave;&nbsp; un semaforo?<br>
Dare una definizione delle operazioni <em>up</em> e <em>down</em>
(anche
chiamate <em>P</em> e <em>V</em> oppure <em>wait</em> e <em>signal</em>),
e<br>
spiegare come queste possano essere implementate (in particolare come
si possa
garantire la loro atomicit&agrave;).<br>
</p>
<p><i><b>Soluzioni<br>
</b></i>Un meccanismo di sincronizzazione per processi concorrenti
implementato
attraverso una variabile intera modificata<br>
atomicamente (...funzionamento, implementazione con code di processi,
ecc).</p>
<p><br>
<span style="font-weight: bold;">Domanda 3</span><br>
Descrivere l'algoritmo di base per la&nbsp; sostituzione di pagine
basato sul
Working Set.<span style="font-weight: bold;"><br>
</span></p>
<p><span style="font-weight: bold;">
<span style="font-style: italic;">Soluzione:</span><br>
</span>Working set=insieme delle pagine utilizzate correntemente
da un processo.<span style="font-weight: bold;"><br>
</span>Il s.o. mantiene un'approsimazione del working set di
ogni singolo processo in memoria.<br>
Si seleziona una pagina al di fuori del working set.<br>
Ad esempio, si associa il tempo di ultimo uso, e fissato un paramentro
di anzianita' di seleziona<br>
una pagina con eta' maggiore del parametro.<br>
Possibili implementazioni: WS con tempo di ultimo utilizzo (...),
WSClock (...).</p>
<p><span style="font-weight: bold;"><br>
Domanda 4</span><br>
Come sono organizzati i frame liberi della memoria principale in
Windows 2000?</p>
<p><span style="font-weight: bold;">Soluzione:</span><br>
Sono organizzati in 4 liste: pagine modificate, in attesa, libere,
azzerate.<br>
Il gestore e i demoni spostano le pagine da una lista all'altra:<br>
Dopo un page fault la pagina rimpiazzata va in una tra le liste
modificata/in attesa <br>
ecc ....
<br>
<br>
<span style="font-weight: bold;">D</span><span
 style="font-weight: bold;">omanda
5</span><br>
A cosa serve, come e' organizzata, e come viene usata la tabella dei
file aperti
di in Unix?<br>
</p>
<p><span style="font-weight: bold;"><span style="font-style: italic;">Soluzione:</span><br>
</span>Unix tiene traccia dei file aperti sia localmente
(tabella dei file associati ad un processo)<br>
sia globalmente (tabella dei descrittori dei file aperti).<br>
La prima tabella contiene dei puntatori alle entry della seconda.<br>
Operazioni quali "open" restituiscono un puntatore ad una entry della
tabella dei file "locale".<br>
La seconda tabella mantiene informazioni quali la posizione nel file e
il puntatore all'inode del file.<br>
In tal modo padre e figlio possono condividere ad. es la posizione
corrente nel file dopo una fork.<span style="font-weight: bold;"><br>
</span>Un processo scorrelato&nbsp; da essi otterra' invece una
nuova entry (e quindi un nuovo cursore nel file).<br>
<br>
<span style="font-weight: bold;">Esercizio 1<br>
</span>Considerate i seguenti&nbsp; processi<br>
</p>
<table cellpadding="2" cellspacing="2" border="0"
 style="text-align: left; width: 700px;">
  <tbody>
    <tr>
      <td style="vertical-align: top; text-align: left;" rowspan="1"
 colspan="2"><span style="font-weight: bold;">Risorse condivise</span><br>
&nbsp; <span style="font-weight: bold;">semaphore</span>&nbsp; S=<span
 style="font-weight: bold;">1</span>, T=<span style="font-weight: bold;">1</span>,
U=<span style="font-weight: bold;">0</span>;<br>
&nbsp; <span style="font-weight: bold;">int</span> x=0;<br>
      </td>
      <td style="vertical-align: top;"><br>
      </td>
    </tr>
    <tr>
      <td style="vertical-align: top;"><span style="font-weight: bold;">Processo</span>
P1<br>
{<br>
      <span style="font-weight: bold;">&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;
down</span>(&amp;S);<br>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; <span style="font-weight: bold;">if</span>
(x=0) <span style="font-weight: bold;">then</span> <span
 style="font-weight: bold;">up</span>(&amp;T)<br>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;
      <span style="font-weight: bold;">else</span> <span
 style="font-weight: bold;">up</span>(&amp;U);<br>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; x:=3;<br>
      <span style="font-weight: bold;">&nbsp;&nbsp;&nbsp;&nbsp; write</span>(x);<br>
}<br>
      </td>
      <td style="vertical-align: top; width: 50%;"><span
 style="font-weight: bold;">Processo</span> P2<br>
{<br>
&nbsp;&nbsp;&nbsp; <span style="font-weight: bold;">down</span>(&amp;T);<br>
&nbsp;&nbsp;&nbsp; x:=1;<br>
&nbsp;&nbsp;&nbsp; <span style="font-weight: bold;">up</span>(&amp;S);&nbsp;&nbsp;&nbsp;<br>
}<br>
      </td>
      <td style="vertical-align: top;"><span style="font-weight: bold;">Processo</span>
P3<br>
{<br>
&nbsp;&nbsp;&nbsp; <span style="font-weight: bold;">down</span>(&amp;U);&nbsp;<br>
&nbsp;&nbsp;&nbsp; x:=10;<br>
&nbsp;&nbsp;&nbsp; <span style="font-weight: bold;">up</span>(&amp;S);<br>
}</td>
    </tr>
  </tbody>
</table>
<br>
supponete che i processi vengano eseguiti concorrentemente sulla stessa
CPU.
<p class="MsoHeader"><o:p></o:p>
</p>
<!--[if !supportEmptyParas]-->
<ol>
  <li>In questo programma possono verificarsi <span
 style="font-weight: bold;">race conditions</span> per la variabile x?
(Motivare la risposta)<br>
    <br>
  </li>
  <li>Quali output vengono prodotti da tale programma concorrente?
(Motivare la risposta)<br>
    <br>
  </li>
  <li>Cosa succede se inseriamo l'istruzione<span
 style="font-weight: bold;"> down</span>(&amp;S) nel processo <span
 style="font-weight: bold;">P1</span> subito prima dell'istruzione <span
 style="font-weight: bold;">write</span>(x)?<span
 style="font-weight: bold;"><br>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; ...</span><br>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; x:=3;<br>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; down(&amp;S);<br>
    <span style="font-weight: bold;">&nbsp;&nbsp;&nbsp;&nbsp; write</span>(x);<br>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; ...<br>
  </li>
</ol>
<span style="font-weight: bold;"><span style="font-style: italic;">Soluzione</span><br>
</span><br>
<li>Si, la variabile x non 'e protetta adeguatamente. Ad esempio, P1
e P2 possono accedere ad x simultaneamente.<br>
  <br>
</li>
<li>In generale: P1 e P2 lavorano in concorrenza (race conditions su
x). <br>
P3 puo partire solo dopo P2 e solo se P3 pone x=1;<br>
Quando attivi P1 e P3 lavorano in concorrenza (race conditions su x).<br>
Vi sono quindi vari interleaving:<br>
</li>
<ol>
  <li>Viene eseguito prima tutto P1: stampa 3<br>
  </li>
  <li>Viene eseguito P1 fino a x:=3, poi P2 pone x a 1, e quindi P2
stampa 1<br>
  </li>
  <li>Viene eseguito prima P2, poi P1 che trova x&gt;0, sveglia P3,
P3 pero' e' l'ultimo a modificare x: stampa 3<br>
  </li>
  <li>Viene eseguito prima P2, poi P1 che trova x&gt;0, sveglia P3,
si blocca dopo aver modificato x, poi viene mandato in esecuzione P3, e
poi si torna a P1: stampa 10</li>
</ol>
<li>Cosi' facendo inseriamo un punto di sincronizzazione in P1:
write(x) verra' eseguita solo se P2 o P3 hanno prima eseguito una up.<br>
Tuttavia rimangono le race conditions tra i tre assegnamenti. <br>
Quindi i possibili output rimangono sempre 1, 3 e 10.</li>
<br>
<span style="font-weight: bold;"><br>
Esercizio 2<br>
<br>
</span>Considerate i seguenti Job:<br>
<br>
<table cellpadding="2" cellspacing="2" border="0"
 style="text-align: left; width: 400px;">
  <tbody>
    <tr>
      <td style="vertical-align: top; font-weight: bold;">Job<br>
      </td>
      <td style="vertical-align: top; font-weight: bold;">Burst time<br>
      </td>
      <td style="vertical-align: top; font-weight: bold;">Tempo di
arrivo<br>
      </td>
    </tr>
    <tr>
      <td style="vertical-align: top;">A<br>
      </td>
      <td style="vertical-align: top;">2<br>
      </td>
      <td style="vertical-align: top;">0<br>
      </td>
    </tr>
    <tr>
      <td style="vertical-align: top;">B<br>
      </td>
      <td style="vertical-align: top;">6<br>
      </td>
      <td style="vertical-align: top;">1<br>
      </td>
    </tr>
    <tr>
      <td style="vertical-align: top;">C<br>
      </td>
      <td style="vertical-align: top;">5<br>
      </td>
      <td style="vertical-align: top;">4<br>
      </td>
    </tr>
    <tr>
      <td style="vertical-align: top;">D</td>
      <td style="vertical-align: top;">3<br>
      </td>
      <td style="vertical-align: top;">7<br>
      </td>
    </tr>
  </tbody>
</table>
<br>
<br>
Calcolare il tempo di esecuzione necessario a completare ogni job in
ognuno dei
seguenti casi:<br>
<ol>
  <li>scheduler SJF&nbsp; <span style="font-weight: bold;">con
preemption<br>
    </span><br>
  </li>
  <li>scheduler round robin con <span style="font-weight: bold;">quanto
di 2 unita'</span> (e coda per i processi in attesa/nuovi processi)<br>
    <br>
  </li>
</ol>
<span style="font-style: italic; font-weight: bold;">Soluzione</span><span
 style="font-weight: bold;"><br>
<br>
</span>
<ol>
  <li>SJF cn preemption<br>
Gantt chart<br>
A (0-2) B (2-7) D (8-11) C (11-16)<br>
    <br>
Tempi compl:<br>
A=2<br>
B=7<br>
C=12<br>
D=4</li>
  <li>RR<br>
Gantt chart<br>
A(0-2) B(2-4) C(4-6)&nbsp; B(6-8) C(8-10) D(10-12) B (12-14) C(14-15)
D(15-16)<br>
    <br>
Tempi compl:<br>
A=2<br>
B=13<br>
C=11<br>
D=12</li>
</ol>
<span style="font-weight: bold;">Esercizio 3</span><br>
Considerare la seguente stringa di riferimenti alla memoria di un
processo in un
sistema con memoria virtuale<br>
<p>S = 10 6 2 4 6 8 3 1 4 5 11 8 7 6 10 9 7 8 11 2<br>
</p>
Illustrare il comportamento dell'algoritmo LRU di sostituzione delle
pagine per
una memoria fisica<br>
di 5 blocchi.&nbsp; Calcolare il numero di page fault che si verificano.<br>
<span style="font-weight: bold;"><br>
</span>
<p><span style="font-weight: bold;">Soluzione<br>
<br>
</span>
<table cellpadding="2" cellspacing="2" border="1"
 style="text-align: left; width: 100%;">
  <tbody>
    <tr>
      <td
 style="vertical-align: top; font-weight: bold; background-color: rgb(255, 255, 0);">Rif.<br>
      </td>
      <td
 style="vertical-align: top; font-weight: bold; background-color: rgb(255, 255, 0);">10<br>
      </td>
      <td
 style="vertical-align: top; font-weight: bold; background-color: rgb(255, 255, 0);">6<br>
      </td>
      <td
 style="vertical-align: top; font-weight: bold; background-color: rgb(255, 255, 0);">2<br>
      </td>
      <td
 style="vertical-align: top; font-weight: bold; background-color: rgb(255, 255, 0);">4<br>
      </td>
      <td
 style="vertical-align: top; font-weight: bold; background-color: rgb(255, 255, 0);">6<br>
      </td>
      <td
 style="vertical-align: top; font-weight: bold; background-color: rgb(255, 255, 0);">8<br>
      </td>
      <td
 style="vertical-align: top; font-weight: bold; background-color: rgb(255, 255, 0);">3<br>
      </td>
      <td
 style="vertical-align: top; font-weight: bold; background-color: rgb(255, 255, 0);">1<br>
      </td>
      <td
 style="vertical-align: top; font-weight: bold; background-color: rgb(255, 255, 0);">4<br>
      </td>
      <td
 style="vertical-align: top; font-weight: bold; background-color: rgb(255, 255, 0);">5<br>
      </td>
      <td
 style="vertical-align: top; font-weight: bold; background-color: rgb(255, 255, 0);">11<br>
      </td>
      <td
 style="vertical-align: top; font-weight: bold; background-color: rgb(255, 255, 0);">8<br>
      </td>
      <td
 style="vertical-align: top; font-weight: bold; background-color: rgb(255, 255, 0);">7<br>
      </td>
      <td
 style="vertical-align: top; font-weight: bold; background-color: rgb(255, 255, 0);">6<br>
      </td>
      <td
 style="vertical-align: top; font-weight: bold; background-color: rgb(255, 255, 0);">10<br>
      </td>
      <td
 style="vertical-align: top; font-weight: bold; background-color: rgb(255, 255, 0);">9<br>
      </td>
      <td
 style="vertical-align: top; font-weight: bold; background-color: rgb(255, 255, 0);">7<br>
      </td>
      <td
 style="vertical-align: top; font-weight: bold; background-color: rgb(255, 255, 0);">8<br>
      </td>
      <td
 style="vertical-align: top; font-weight: bold; background-color: rgb(255, 255, 0);">11<br>
      </td>
      <td
 style="vertical-align: top; font-weight: bold; background-color: rgb(255, 255, 0);">2<br>
      </td>
    </tr>
    <tr>
      <td style="vertical-align: top;">1<br>
      </td>
      <td style="vertical-align: top;">10<br>
      </td>
      <td style="vertical-align: top;">10<br>
      </td>
      <td style="vertical-align: top;">10<br>
      </td>
      <td style="vertical-align: top;">10<br>
      </td>
      <td style="vertical-align: top;">10<br>
      </td>
      <td style="vertical-align: top;"><span style="font-weight: bold;">10</span><br>
      </td>
      <td style="vertical-align: top;">3<br>
      </td>
      <td style="vertical-align: top;">3<br>
      </td>
      <td style="vertical-align: top;">3<br>
      </td>
      <td style="vertical-align: top;">3<br>
      </td>
      <td style="vertical-align: top;"><span style="font-weight: bold;">3</span><br>
      </td>
      <td style="vertical-align: top;">8<br>
      </td>
      <td style="vertical-align: top;">8<br>
      </td>
      <td style="vertical-align: top;">8<br>
      </td>
      <td style="vertical-align: top;">8<br>
      </td>
      <td style="vertical-align: top;">8<br>
      </td>
      <td style="vertical-align: top;">8<br>
      </td>
      <td style="vertical-align: top;">8<br>
      </td>
      <td style="vertical-align: top;">8<br>
      </td>
      <td style="vertical-align: top;">8<br>
      </td>
    </tr>
    <tr>
      <td style="vertical-align: top;">2<br>
      </td>
      <td style="vertical-align: top;"><br>
      </td>
      <td style="vertical-align: top;">6<br>
      </td>
      <td style="vertical-align: top;">6<br>
      </td>
      <td style="vertical-align: top;">6<br>
      </td>
      <td style="vertical-align: top;">6<br>
      </td>
      <td style="vertical-align: top;">6<br>
      </td>
      <td style="vertical-align: top;">6<br>
      </td>
      <td style="vertical-align: top;">6<br>
      </td>
      <td style="vertical-align: top;"><span style="font-weight: bold;">6</span><br>
      </td>
      <td style="vertical-align: top;">5<br>
      </td>
      <td style="vertical-align: top;">5<br>
      </td>
      <td style="vertical-align: top;">5<br>
      </td>
      <td style="vertical-align: top;">5<br>
      </td>
      <td style="vertical-align: top;"><span style="font-weight: bold;">5</span><br>
      </td>
      <td style="vertical-align: top;">10<br>
      </td>
      <td style="vertical-align: top;">10<br>
      </td>
      <td style="vertical-align: top;">10<br>
      </td>
      <td style="vertical-align: top;">10<br>
      </td>
      <td style="vertical-align: top; font-weight: bold;">10<br>
      </td>
      <td style="vertical-align: top;">2<br>
      </td>
    </tr>
    <tr>
      <td style="vertical-align: top;">3<br>
      </td>
      <td style="vertical-align: top;"><br>
      </td>
      <td style="vertical-align: top;"><br>
      </td>
      <td style="vertical-align: top;">2<br>
      </td>
      <td style="vertical-align: top;">2<br>
      </td>
      <td style="vertical-align: top;">2<br>
      </td>
      <td style="vertical-align: top;">2<br>
      </td>
      <td style="vertical-align: top;"><span style="font-weight: bold;">2</span><br>
      </td>
      <td style="vertical-align: top;">1<br>
      </td>
      <td style="vertical-align: top;">1<br>
      </td>
      <td style="vertical-align: top;">1<br>
      </td>
      <td style="vertical-align: top;">1<br>
      </td>
      <td style="vertical-align: top;"><span style="font-weight: bold;">1</span><br>
      </td>
      <td style="vertical-align: top;">7<br>
      </td>
      <td style="vertical-align: top;">7<br>
      </td>
      <td style="vertical-align: top;">7<br>
      </td>
      <td style="vertical-align: top;">7<br>
      </td>
      <td style="vertical-align: top;">7<br>
      </td>
      <td style="vertical-align: top;">7<br>
      </td>
      <td style="vertical-align: top;">7<br>
      </td>
      <td style="vertical-align: top;">7<br>
      </td>
    </tr>
    <tr>
      <td style="vertical-align: top;">4<br>
      </td>
      <td style="vertical-align: top;"><br>
      </td>
      <td style="vertical-align: top;"><br>
      </td>
      <td style="vertical-align: top;"><br>
      </td>
      <td style="vertical-align: top;">4<br>
      </td>
      <td style="vertical-align: top;">4<br>
      </td>
      <td style="vertical-align: top;">4<br>
      </td>
      <td style="vertical-align: top;">4<br>
      </td>
      <td style="vertical-align: top;">4<br>
      </td>
      <td style="vertical-align: top;">4<br>
      </td>
      <td style="vertical-align: top;">4<br>
      </td>
      <td style="vertical-align: top;">4<br>
      </td>
      <td style="vertical-align: top;">4<br>
      </td>
      <td style="vertical-align: top;"><span style="font-weight: bold;">4</span><br>
      </td>
      <td style="vertical-align: top;">6<br>
      </td>
      <td style="vertical-align: top;">6<br>
      </td>
      <td style="vertical-align: top;">6<br>
      </td>
      <td style="vertical-align: top;">6<br>
      </td>
      <td style="vertical-align: top;"><span style="font-weight: bold;">6</span><br>
      </td>
      <td style="vertical-align: top;">11<br>
      </td>
      <td style="vertical-align: top;">11<br>
      </td>
    </tr>
    <tr>
      <td style="vertical-align: top;">5<br>
      </td>
      <td style="vertical-align: top;"><br>
      </td>
      <td style="vertical-align: top;"><br>
      </td>
      <td style="vertical-align: top;"><br>
      </td>
      <td style="vertical-align: top;"><br>
      </td>
      <td style="vertical-align: top;"><br>
      </td>
      <td style="vertical-align: top;">8<br>
      </td>
      <td style="vertical-align: top;">8<br>
      </td>
      <td style="vertical-align: top;">8<br>
      </td>
      <td style="vertical-align: top;">8<br>
      </td>
      <td style="vertical-align: top;"><span style="font-weight: bold;">8</span><br>
      </td>
      <td style="vertical-align: top;">11<br>
      </td>
      <td style="vertical-align: top;">11<br>
      </td>
      <td style="vertical-align: top;">11<br>
      </td>
      <td style="vertical-align: top;">11<br>
      </td>
      <td style="vertical-align: top;"><span style="font-weight: bold;">11</span><br>
      </td>
      <td style="vertical-align: top;">9<br>
      </td>
      <td style="vertical-align: top;">9<br>
      </td>
      <td style="vertical-align: top;">9<br>
      </td>
      <td style="vertical-align: top;">9<br>
      </td>
      <td style="vertical-align: top;">9<br>
      </td>
    </tr>
    <tr>
      <td
 style="vertical-align: top; background-color: rgb(102, 255, 255);">Page
Fault<br>
      </td>
      <td
 style="vertical-align: top; background-color: rgb(102, 255, 255);">*<br>
      </td>
      <td
 style="vertical-align: top; background-color: rgb(102, 255, 255);">*<br>
      </td>
      <td
 style="vertical-align: top; background-color: rgb(102, 255, 255);">*<br>
      </td>
      <td
 style="vertical-align: top; background-color: rgb(102, 255, 255);">*<br>
      </td>
      <td
 style="vertical-align: top; background-color: rgb(102, 255, 255);"><br>
      </td>
      <td
 style="vertical-align: top; background-color: rgb(102, 255, 255);">*<br>
      </td>
      <td
 style="vertical-align: top; background-color: rgb(102, 255, 255);">*<br>
      </td>
      <td
 style="vertical-align: top; background-color: rgb(102, 255, 255);">*<br>
      </td>
      <td
 style="vertical-align: top; background-color: rgb(102, 255, 255);"><br>
      </td>
      <td
 style="vertical-align: top; background-color: rgb(102, 255, 255);">*<br>
      </td>
      <td
 style="vertical-align: top; background-color: rgb(102, 255, 255);">*<br>
      </td>
      <td
 style="vertical-align: top; background-color: rgb(102, 255, 255);">*<br>
      </td>
      <td
 style="vertical-align: top; background-color: rgb(102, 255, 255);">*<br>
      </td>
      <td
 style="vertical-align: top; background-color: rgb(102, 255, 255);">*<br>
      </td>
      <td
 style="vertical-align: top; background-color: rgb(102, 255, 255);">*<br>
      </td>
      <td
 style="vertical-align: top; background-color: rgb(102, 255, 255);">*<br>
      </td>
      <td
 style="vertical-align: top; background-color: rgb(102, 255, 255);"><br>
      </td>
      <td
 style="vertical-align: top; background-color: rgb(102, 255, 255);"><br>
      </td>
      <td
 style="vertical-align: top; background-color: rgb(102, 255, 255);">*<br>
      </td>
      <td
 style="vertical-align: top; background-color: rgb(102, 255, 255);">*<br>
      </td>
    </tr>
  </tbody>
</table>
<span style="font-weight: bold;"><br>
In neretto: </span>pagina selezionata<span style="font-weight: bold;"><br>
Numero di page fault: </span>16
</p>
<p>&nbsp;</p>
<p><span style="font-weight: bold;">Esercizio 4<br>
</span>Dato un file system FAT con blocchi di 3KB&nbsp; e il seguente
frammento
di FAT,<span lang="IT"><br>
dire in quali blocchi fisici sono collocati i seguenti byte:<br>
</span></p>
<ol>
  <li><span lang="IT">byte 6758 del file "pippo" che inizia al blocco 8<br>
    </span></li>
  <li><span lang="IT">byte 4096 del file "pluto" che inizia al blocco 3</span></li>
  <li><span lang="IT">byte 2044 del file "paperino" che inizia al
blocco 4<br>
    </span></li>
</ol>
<p class="MsoNormal" style="border: medium none ; padding: 0cm;"><span
 lang="IT">Frammento
FAT :</span></p>
<table cellpadding="2" cellspacing="2" border="0"
 style="text-align: left; width: 100px;">
  <tbody>
    <tr>
      <td style="vertical-align: top;">Entry<br>
      </td>
      <td style="vertical-align: top;">Contenuto<br>
      </td>
    </tr>
    <tr>
      <td style="vertical-align: top;">0<br>
      </td>
      <td style="vertical-align: top;">7<br>
      </td>
    </tr>
    <tr>
      <td style="vertical-align: top;">1<br>
      </td>
      <td style="vertical-align: top;">2<br>
      </td>
    </tr>
    <tr>
      <td style="vertical-align: top;">2<br>
      </td>
      <td style="vertical-align: top;">11<br>
      </td>
    </tr>
    <tr>
      <td style="vertical-align: top;">3<br>
      </td>
      <td style="vertical-align: top;">5<br>
      </td>
    </tr>
    <tr>
      <td style="vertical-align: top;">4<br>
      </td>
      <td style="vertical-align: top;">3<br>
      </td>
    </tr>
    <tr>
      <td style="vertical-align: top;">5<br>
      </td>
      <td style="vertical-align: top;">20<br>
      </td>
    </tr>
    <tr>
      <td style="vertical-align: top;">6<br>
      </td>
      <td style="vertical-align: top;">13<br>
      </td>
    </tr>
    <tr>
      <td style="vertical-align: top;">7<br>
      </td>
      <td style="vertical-align: top;">1<br>
      </td>
    </tr>
    <tr>
      <td style="vertical-align: top;">8<br>
      </td>
      <td style="vertical-align: top;">0<br>
      </td>
    </tr>
  </tbody>
</table>
&nbsp;
<p><span style="font-weight: bold; font-style: italic;">Soluzione</span><br>
</p>
<ol>
  <li>Dim. blocco = 3*1024= 3072 bytes. Il byte 6758 di pippo si trova
nel terzo blocco (6758/3072 =2.1).<br>
Percorrendo la FAT: I blocco: 8, II blocco: 0, III blocco: 7.<br>
Quindi l'indirizzo fisico del blocco e' <span
 style="font-weight: bold;">7</span><br>
    <br>
  </li>
  <li>Il byte 4097 di pluto si trova nel secondo blocco, quindi nel
blocco fisico <span style="font-weight: bold;">5</span>.<br>
    <br>
  </li>
  <li><span lang="IT">Il byte 2044 del file "paperino" si trova nel
primo blocco, quindi </span>nel blocco fisico <span
 style="font-weight: bold;">4</span>.<br>
  </li>
</ol>
<p><span style="font-weight: bold;">Esercizio 5</span><br>
In una organizzazione dell'allocazione dei file simile a quella
adottata in UNIX
vi sono 13 puntatori nel<br>
descrittore di file&nbsp; (mantenuto in memoria durante l'accesso al
file) di
cui</p>
<ul>
  <li>10 puntatori diretti a blocchi</li>
  <li>2 puntatori indiretti a blocchi</li>
  <li>1 puntatore doppiamente indiretto a blocchi</li>
</ul>
Se la dimensione di un blocco &egrave; 1Kb, e un puntatore occupa 2
bytes:<br>
<ol>
  <li>&nbsp;Qual &egrave; la dim. massima di un file per il quale non
sono necessari accessi aggiuntivi&nbsp; per accedere<br>
a qualunque blocco?<br>
    <br>
  </li>
  <li>&nbsp;Qual &egrave; la dim. massima di un file?<br>
    <br>
  </li>
  <li>Quanti accessi aggiuntivi sono necessari per accedere al byte
alla posizione 2000K?<br>
  </li>
</ol>
<span style="font-weight: bold;">Soluzione<br>
</span>Un blocco puo' contenere (dim. blocco/dim.puntatore=) 1024/2=512
puntatori a blocchi.<span style="font-weight: bold;"><br>
</span>
<ol>
  <li>La dim. massima di un file con blocchi accessibili solo tramite
puntatori diretti e' 10*1KB=10 KB.<br>
    <br>
  </li>
  <li>La dim. massima di un file indirizzabile e' 10 KB+1024 KB+512<sup>2
    </sup>KB= 263178 KB.<br>
    <br>
  </li>
  <li>2000K&gt; 1034KB. Quindi il 2000000-esimo byte di un file si
trova
in un blocco accessibile tramite puntatore doppiamente indiretto: <br>
occorrono quindi 2 accessi aggiuntivi (uno alla tabella esterna e uno a
quella interna).<br>
  </li>
</ol>
<br>
</body>
</html>
